<template>
  <div>
    <rui-accordion v-for="tag in tags"
                   :key="tag.base"
                   :no-content="tag.items.size === 0">
      <template #header>
        <label v-if="tag.items.size === 0">
          <input type="checkbox"
                 :name="`tags[]`"
                 :checked="modelValue.includes(tag.base)"
                 :value="tag.base"
                 @change="toggle">
          {{ tag.name }}
        </label>
        <template v-else>
          <rui-icon name="blank" />
          {{ tag.name }}
        </template>
      </template>
      <div v-for="item in tag.items" :key="item">
        <label>
          <input type="checkbox"
                 :name="`tags[]`"
                 :checked="modelValue.includes(`${tag.base}::${item}`)"
                 :value="`${tag.base}::${item}`"
                 @change="toggle">
          {{ item }}
        </label>
      </div>
    </rui-accordion>
  </div>
</template>

<script>
import RuiAccordion from '@experiments-labs/rise_ui/src/components/DataDisplay/Accordion/Accordion.vue'
import RuiIcon from '@experiments-labs/rise_ui/src/components/Icon/Icon.vue'

export default {
  name: 'GpaTagFilters',
  emits: [
    'update:modelValue',
  ],
  components: { RuiIcon, RuiAccordion },
  props: {
    modelValue: { required: true, type: Array },
    visible: { required: false, type: Boolean, default: false },
  },
  data () {
    return {
      selected: this.$props.modelValue,
    }
  },
  computed: {
    tags () { return this.$store.getters.tags },
  },
  methods: {
    toggle (event) {
      const tag = event.target.value
      const index = this.selected.findIndex(s => s === tag)

      if (index > -1) this.selected.splice(index, 1)
      else this.selected.push(tag)
    },
    validate () {
      this.$emit('update:modelValue', this.selected)
    },
  },
  watch: {
    modelValue (newValue) { this.selected = newValue },
  },
}
</script>
